/***************************************************************************
 *   Copyright (C) 2003 by Dan Muller                                      *
 *   dan@verliba.cz                                                        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif
#include <iostream>
#include <cserverdc.h>
#include "script_api.h"

using namespace std;
using namespace nDirectConnect;

cServerDC *GetCurrentVerlihub()
{
	return (cServerDC *)cServerDC::sCurrentServer;
}

cUser *GetUser(char *nick)
{
	cServerDC *server = GetCurrentVerlihub();
	if ( server == NULL) {
		cerr << "Server verlihub is unfortunately not running or not found." << endl;
		return NULL;
	}
	cUser *usr = server->mUserList.GetUserByNick(string(nick));
	if (usr != NULL && usr->mxConn == NULL) {
		return NULL;
	}
	return usr;
}

bool SendDataToUser(char *data, char *nick)
{
	cUser *usr = GetUser(nick);
	if (usr != NULL) {
		string omsg(data);
		usr->mxConn->Send(omsg, true);
	}
	return true;
}

bool KickUser(char *OP,char *nick, char *reason)
{
	cServerDC *server = GetCurrentVerlihub();
	cUser *OPusr = GetUser(OP);
	ostringstream os;
	if (OPusr != NULL) {
		if ( server != NULL) {
			server->DCKickNick(&os,OPusr, nick, reason, cServerDC::eKCK_Drop|cServerDC::eKCK_Reason|cServerDC::eKCK_PM|cServerDC::eKCK_TBAN);
			return true;
		} else return false;
	}else return false;
}

bool SendDataToAll(char *data, int min_class,  int max_class)
{
	cServerDC *server = GetCurrentVerlihub();
	if ( server == NULL) {
		cerr << "Server verlihub is unfortunately not running or not found." << endl;
		return false;
	}
	if (min_class > max_class) return false;
	string omsg(data);
	if (min_class >= 0)
		server->mUserList.SendToAll(omsg,true, false);
	else if (min_class >= 3)
		server->mOpList.SendToAll(omsg,true, false);
	return true;
}

bool CloseConnection(char *nick)
{
	cUser *usr = GetUser(nick);
	if (usr != NULL) {
		usr->mxConn->CloseNow();
		return true;
	} else return false;
}

char *GetMyINFO(char *nick)
{
	cUser *usr = GetUser(nick);
	if (usr != NULL) return (char*) usr->mMyINFO.data();
	else return (char *)"";
}

int GetUserClass(char * nick)
{
    cUser *usr = GetUser(nick);
    if(usr != NULL) return usr->mClass;
    else return -1;
}

bool Ban(char *nick, unsigned howlong, int bantype)
{
}

char * ParseCommand(char *command_line)
{
	
}

